<html>
<head>
<title>OgreAnimation.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreAnimation.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreAnimation_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Animation_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Animation_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimable_8h.html">OgreAnimable.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimationTrack_8h.html">OgreAnimationTrack.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreAnimationState_8h.html">OgreAnimationState.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00048"></a>00048     <span class="keyword">class </span>Animation;
<a name="l00049"></a>00049     
<a name="l00057"></a><a class="code" href="classOgre_1_1AnimationContainer.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationContainer.html" title="An animation container interface, which allows generic access to sibling animations.">AnimationContainer</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00061"></a>00061         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumAnimations(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00062"></a>00062         
<a name="l00064"></a>00064         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span> = 0;
<a name="l00065"></a>00065         
<a name="l00067"></a>00067         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span> = 0;
<a name="l00068"></a>00068         
<a name="l00070"></a>00070         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* createAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length) = 0;
<a name="l00071"></a>00071         
<a name="l00073"></a>00073         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074         
<a name="l00076"></a>00076         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) = 0;
<a name="l00077"></a>00077         
<a name="l00078"></a>00078     };
<a name="l00089"></a><a class="code" href="classOgre_1_1Animation.html">00089</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAlloc</a>
<a name="l00090"></a>00090     {
<a name="l00091"></a>00091 
<a name="l00092"></a>00092     <span class="keyword">public</span>:
<a name="l00094"></a><a class="code" href="classOgre_1_1Animation.html#accd627249080f5a09332f55bed1d2dcd">00094</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Animation.html#accd627249080f5a09332f55bed1d2dcd" title="The types of animation interpolation available.">InterpolationMode</a>
<a name="l00095"></a>00095         {
<a name="l00097"></a><a class="code" href="classOgre_1_1Animation.html#accd627249080f5a09332f55bed1d2dcda262ee3e33fe08932773f377f2595b142">00097</a>             <a class="code" href="classOgre_1_1Animation.html#accd627249080f5a09332f55bed1d2dcda262ee3e33fe08932773f377f2595b142" title="Values are interpolated along straight lines.">IM_LINEAR</a>,
<a name="l00099"></a><a class="code" href="classOgre_1_1Animation.html#accd627249080f5a09332f55bed1d2dcdaed6662637d5b6a2f79cdf5b60318fc9a">00099</a>             IM_SPLINE
<a name="l00100"></a>00100         };
<a name="l00101"></a>00101 
<a name="l00103"></a><a class="code" href="classOgre_1_1Animation.html#afbc674fea08fd85e8ad73a10dc852c32">00103</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Animation.html#afbc674fea08fd85e8ad73a10dc852c32" title="The types of rotational interpolation available.">RotationInterpolationMode</a>
<a name="l00104"></a>00104         {
<a name="l00108"></a><a class="code" href="classOgre_1_1Animation.html#afbc674fea08fd85e8ad73a10dc852c32a9b235462ed2b49ff928bfc037775e18f">00108</a>             <a class="code" href="classOgre_1_1Animation.html#afbc674fea08fd85e8ad73a10dc852c32a9b235462ed2b49ff928bfc037775e18f" title="Values are interpolated linearly.">RIM_LINEAR</a>,
<a name="l00112"></a><a class="code" href="classOgre_1_1Animation.html#afbc674fea08fd85e8ad73a10dc852c32ae2332380356ba1b4aa4b30eef722ce40">00112</a>             RIM_SPHERICAL
<a name="l00113"></a>00113         };
<a name="l00118"></a>00118         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length);
<a name="l00119"></a>00119         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>();
<a name="l00120"></a>00120 
<a name="l00122"></a>00122         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00125"></a>00125         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getLength(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00131"></a>00131         <span class="keywordtype">void</span> setLength(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> len);
<a name="l00132"></a>00132 
<a name="l00137"></a>00137         <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* createNodeTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00138"></a>00138 
<a name="l00143"></a>00143         <a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a>* createNumericTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00144"></a>00144 
<a name="l00152"></a>00152         <a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a>* createVertexTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> animType);
<a name="l00153"></a>00153 
<a name="l00162"></a>00162         <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* createNodeTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node);
<a name="l00163"></a>00163 
<a name="l00169"></a>00169         <a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a>* createNumericTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, 
<a name="l00170"></a>00170             <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&amp; anim);
<a name="l00171"></a>00171 
<a name="l00178"></a>00178         <a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a>* createVertexTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, 
<a name="l00179"></a>00179             <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* data, <a class="code" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e" title="Type of vertex animation.">VertexAnimationType</a> animType);
<a name="l00180"></a>00180 
<a name="l00182"></a>00182         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumNodeTracks(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00183"></a>00183 
<a name="l00185"></a>00185         <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* getNodeTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00186"></a>00186 
<a name="l00188"></a>00188         <span class="keywordtype">bool</span> hasNodeTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00189"></a>00189 
<a name="l00191"></a>00191         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumNumericTracks(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00192"></a>00192 
<a name="l00194"></a>00194         <a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a>* getNumericTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00195"></a>00195 
<a name="l00197"></a>00197         <span class="keywordtype">bool</span> hasNumericTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00198"></a>00198 
<a name="l00200"></a>00200         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumVertexTracks(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00201"></a>00201 
<a name="l00203"></a>00203         <a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a>* getVertexTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00204"></a>00204 
<a name="l00206"></a>00206         <span class="keywordtype">bool</span> hasVertexTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00207"></a>00207         
<a name="l00209"></a>00209         <span class="keywordtype">void</span> destroyNodeTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00210"></a>00210 
<a name="l00212"></a>00212         <span class="keywordtype">void</span> destroyNumericTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00213"></a>00213 
<a name="l00215"></a>00215         <span class="keywordtype">void</span> destroyVertexTrack(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00216"></a>00216 
<a name="l00218"></a>00218         <span class="keywordtype">void</span> destroyAllTracks(<span class="keywordtype">void</span>);
<a name="l00219"></a>00219 
<a name="l00221"></a>00221         <span class="keywordtype">void</span> destroyAllNodeTracks(<span class="keywordtype">void</span>);
<a name="l00223"></a>00223         <span class="keywordtype">void</span> destroyAllNumericTracks(<span class="keywordtype">void</span>);
<a name="l00225"></a>00225         <span class="keywordtype">void</span> destroyAllVertexTracks(<span class="keywordtype">void</span>);
<a name="l00226"></a>00226 
<a name="l00237"></a>00237         <span class="keywordtype">void</span> apply(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00238"></a>00238 
<a name="l00249"></a>00249         <span class="keywordtype">void</span> applyToNode(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* node, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00250"></a>00250 
<a name="l00261"></a>00261         <span class="keywordtype">void</span> apply(<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* skeleton, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00262"></a>00262 
<a name="l00275"></a>00275         <span class="keywordtype">void</span> apply(<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* skeleton, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <span class="keywordtype">float</span> weight,
<a name="l00276"></a>00276           <span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationState.html#a9eb388325ffd3d479e311a05f519445b" title="Typedef for an array of float values used as a bone blend mask.">AnimationState::BoneBlendMask</a>* blendMask, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale);
<a name="l00277"></a>00277 
<a name="l00287"></a>00287         <span class="keywordtype">void</span> apply(<a class="code" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh.">Entity</a>* entity, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight, <span class="keywordtype">bool</span> software, 
<a name="l00288"></a>00288             <span class="keywordtype">bool</span> hardware);
<a name="l00289"></a>00289 
<a name="l00299"></a>00299         <span class="keywordtype">void</span> applyToAnimable(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&amp; anim, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00300"></a>00300 
<a name="l00308"></a>00308         <span class="keywordtype">void</span> applyToVertexData(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* data, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0);
<a name="l00309"></a>00309 
<a name="l00322"></a>00322         <span class="keywordtype">void</span> setInterpolationMode(InterpolationMode im);
<a name="l00323"></a>00323 
<a name="l00328"></a>00328         InterpolationMode getInterpolationMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00339"></a>00339         <span class="keywordtype">void</span> setRotationInterpolationMode(RotationInterpolationMode im);
<a name="l00340"></a>00340 
<a name="l00345"></a>00345         RotationInterpolationMode getRotationInterpolationMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00346"></a>00346 
<a name="l00347"></a>00347         <span class="comment">// Methods for setting the defaults</span>
<a name="l00354"></a>00354 <span class="comment"></span>        <span class="keyword">static</span> <span class="keywordtype">void</span> setDefaultInterpolationMode(InterpolationMode im);
<a name="l00355"></a>00355 
<a name="l00357"></a>00357         <span class="keyword">static</span> InterpolationMode getDefaultInterpolationMode(<span class="keywordtype">void</span>);
<a name="l00358"></a>00358 
<a name="l00365"></a>00365         <span class="keyword">static</span> <span class="keywordtype">void</span> setDefaultRotationInterpolationMode(RotationInterpolationMode im);
<a name="l00366"></a>00366 
<a name="l00368"></a>00368         <span class="keyword">static</span> RotationInterpolationMode getDefaultRotationInterpolationMode(<span class="keywordtype">void</span>);
<a name="l00369"></a>00369 
<a name="l00370"></a><a class="code" href="classOgre_1_1Animation.html#a687b42ea31dcb2a63430655544b1cd92">00370</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;unsigned short, NodeAnimationTrack*&gt;::type</a> <a class="code" href="classOgre_1_1Animation.html#a687b42ea31dcb2a63430655544b1cd92">NodeTrackList</a>;
<a name="l00371"></a><a class="code" href="classOgre_1_1Animation.html#a102623aa082648ea3fe2023ab30609b3">00371</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;NodeTrackList&gt;</a> <a class="code" href="classOgre_1_1Animation.html#a102623aa082648ea3fe2023ab30609b3">NodeTrackIterator</a>;
<a name="l00372"></a>00372 
<a name="l00373"></a><a class="code" href="classOgre_1_1Animation.html#a5bb1d35a490357a87992a603c5fce642">00373</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;unsigned short, NumericAnimationTrack*&gt;::type</a> <a class="code" href="classOgre_1_1Animation.html#a5bb1d35a490357a87992a603c5fce642">NumericTrackList</a>;
<a name="l00374"></a><a class="code" href="classOgre_1_1Animation.html#adc1167a609195ef97a04e3c6ea1dbe4f">00374</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;NumericTrackList&gt;</a> <a class="code" href="classOgre_1_1Animation.html#adc1167a609195ef97a04e3c6ea1dbe4f">NumericTrackIterator</a>;
<a name="l00375"></a>00375 
<a name="l00376"></a><a class="code" href="classOgre_1_1Animation.html#abd58b24a526b3a8d9a380817da873de4">00376</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;unsigned short, VertexAnimationTrack*&gt;::type</a> <a class="code" href="classOgre_1_1Animation.html#abd58b24a526b3a8d9a380817da873de4">VertexTrackList</a>;
<a name="l00377"></a><a class="code" href="classOgre_1_1Animation.html#a6cf2cea821bb2bc222097322810a8795">00377</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;VertexTrackList&gt;</a> <a class="code" href="classOgre_1_1Animation.html#a6cf2cea821bb2bc222097322810a8795">VertexTrackIterator</a>;
<a name="l00378"></a>00378 
<a name="l00380"></a>00380         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Animation.html#a687b42ea31dcb2a63430655544b1cd92">NodeTrackList</a>&amp; _getNodeTrackList(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00381"></a>00381 
<a name="l00383"></a><a class="code" href="classOgre_1_1Animation.html#ac8e44704bf96b608f1fa7aa0c0b88edf">00383</a>         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">NodeTrackIterator</a> getNodeTrackIterator(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00384"></a>00384 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">NodeTrackIterator</a>(mNodeTrackList.begin(), mNodeTrackList.end()); }
<a name="l00385"></a>00385         
<a name="l00387"></a>00387         <span class="keyword">const</span> NumericTrackList&amp; _getNumericTrackList(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00388"></a>00388 
<a name="l00390"></a><a class="code" href="classOgre_1_1Animation.html#a3baa25475b685e73bc95f07f8abd686e">00390</a>         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">NumericTrackIterator</a> getNumericTrackIterator(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00391"></a>00391 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">NumericTrackIterator</a>(mNumericTrackList.begin(), mNumericTrackList.end()); }
<a name="l00392"></a>00392 
<a name="l00394"></a>00394         <span class="keyword">const</span> VertexTrackList&amp; _getVertexTrackList(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00395"></a>00395 
<a name="l00397"></a><a class="code" href="classOgre_1_1Animation.html#aa862d7cc6c0764a479962ad562373218">00397</a>         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">VertexTrackIterator</a> getVertexTrackIterator(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00398"></a>00398 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">VertexTrackIterator</a>(mVertexTrackList.begin(), mVertexTrackList.end()); }
<a name="l00399"></a>00399 
<a name="l00419"></a>00419         <span class="keywordtype">void</span> optimise(<span class="keywordtype">bool</span> discardIdentityNodeTracks = <span class="keyword">true</span>);
<a name="l00420"></a>00420 
<a name="l00422"></a><a class="code" href="classOgre_1_1Animation.html#aa1e0832cbc4b53d5b66db62bae3b72e4">00422</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html#a7ac5eb4c7cfd2a56392fe863bcb415c0">set&lt;ushort&gt;::type</a> <a class="code" href="classOgre_1_1Animation.html#aa1e0832cbc4b53d5b66db62bae3b72e4" title="A list of track handles.">TrackHandleList</a>;
<a name="l00423"></a>00423 
<a name="l00431"></a>00431         <span class="keywordtype">void</span> _collectIdentityNodeTracks(<a class="code" href="classOgre_1_1Animation.html#aa1e0832cbc4b53d5b66db62bae3b72e4" title="A list of track handles.">TrackHandleList</a>&amp; tracks) <span class="keyword">const</span>;
<a name="l00432"></a>00432 
<a name="l00435"></a>00435         <span class="keywordtype">void</span> _destroyNodeTracks(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Animation.html#aa1e0832cbc4b53d5b66db62bae3b72e4" title="A list of track handles.">TrackHandleList</a>&amp; tracks);
<a name="l00436"></a>00436 
<a name="l00443"></a>00443         <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* clone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; newName) <span class="keyword">const</span>;
<a name="l00444"></a>00444         
<a name="l00447"></a><a class="code" href="classOgre_1_1Animation.html#ad8bcd32239c62f94ac26f07b30de6db0">00447</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Animation.html#ad8bcd32239c62f94ac26f07b30de6db0" title="Internal method used to tell the animation that keyframe list has been changed, which may cause it to...">_keyFrameListChanged</a>(<span class="keywordtype">void</span>) { mKeyFrameTimesDirty = <span class="keyword">true</span>; }
<a name="l00448"></a>00448 
<a name="l00459"></a>00459         <a class="code" href="classOgre_1_1TimeIndex.html" title="Time index object used to search keyframe at the given position.">TimeIndex</a> _getTimeIndex(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos) <span class="keyword">const</span>;
<a name="l00460"></a>00460         
<a name="l00488"></a>00488         <span class="keywordtype">void</span> setUseBaseKeyFrame(<span class="keywordtype">bool</span> useBaseKeyFrame, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> keyframeTime = 0.0f, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; baseAnimName = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00490"></a>00490         <span class="keywordtype">bool</span> getUseBaseKeyFrame() <span class="keyword">const</span>;
<a name="l00492"></a>00492         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBaseKeyFrameTime() <span class="keyword">const</span>;
<a name="l00494"></a>00494         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getBaseKeyFrameAnimationName() <span class="keyword">const</span>;
<a name="l00495"></a>00495         
<a name="l00497"></a>00497         <span class="keywordtype">void</span> _applyBaseKeyFrame();
<a name="l00498"></a>00498         
<a name="l00499"></a>00499         <span class="keywordtype">void</span> _notifyContainer(<a class="code" href="classOgre_1_1AnimationContainer.html" title="An animation container interface, which allows generic access to sibling animations.">AnimationContainer</a>* c);
<a name="l00501"></a>00501         <a class="code" href="classOgre_1_1AnimationContainer.html" title="An animation container interface, which allows generic access to sibling animations.">AnimationContainer</a>* getContainer();
<a name="l00502"></a>00502         
<a name="l00503"></a>00503     <span class="keyword">protected</span>:
<a name="l00505"></a><a class="code" href="classOgre_1_1Animation.html#ad6feb2e94e741b520b4b495de3370d0a">00505</a>         <a class="code" href="classOgre_1_1Animation.html#a687b42ea31dcb2a63430655544b1cd92">NodeTrackList</a> <a class="code" href="classOgre_1_1Animation.html#ad6feb2e94e741b520b4b495de3370d0a" title="Node tracks, indexed by handle.">mNodeTrackList</a>;
<a name="l00507"></a><a class="code" href="classOgre_1_1Animation.html#a7827f78d56ad9617d492ca9db44b0dda">00507</a>         <a class="code" href="classOgre_1_1Animation.html#a5bb1d35a490357a87992a603c5fce642">NumericTrackList</a> <a class="code" href="classOgre_1_1Animation.html#a7827f78d56ad9617d492ca9db44b0dda" title="Numeric tracks, indexed by handle.">mNumericTrackList</a>;
<a name="l00509"></a><a class="code" href="classOgre_1_1Animation.html#a459b6ab4402064f29513d85f11019a8e">00509</a>         <a class="code" href="classOgre_1_1Animation.html#abd58b24a526b3a8d9a380817da873de4">VertexTrackList</a> <a class="code" href="classOgre_1_1Animation.html#a459b6ab4402064f29513d85f11019a8e" title="Vertex tracks, indexed by handle.">mVertexTrackList</a>;
<a name="l00510"></a><a class="code" href="classOgre_1_1Animation.html#ad9b0db95c087917ae1f1b39c8bd78033">00510</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Animation.html#ad9b0db95c087917ae1f1b39c8bd78033">mName</a>;
<a name="l00511"></a>00511 
<a name="l00512"></a><a class="code" href="classOgre_1_1Animation.html#ad276a5a08f9722e7ec3db6010ed46c5d">00512</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Animation.html#ad276a5a08f9722e7ec3db6010ed46c5d">mLength</a>;
<a name="l00513"></a>00513         
<a name="l00514"></a><a class="code" href="classOgre_1_1Animation.html#af12b2e7210e20a1f4753d624997b584e">00514</a>         <a class="code" href="classOgre_1_1Animation.html#accd627249080f5a09332f55bed1d2dcd" title="The types of animation interpolation available.">InterpolationMode</a> <a class="code" href="classOgre_1_1Animation.html#af12b2e7210e20a1f4753d624997b584e">mInterpolationMode</a>;
<a name="l00515"></a><a class="code" href="classOgre_1_1Animation.html#a73cbf633be9d7d066c8592eb7f7201cf">00515</a>         <a class="code" href="classOgre_1_1Animation.html#afbc674fea08fd85e8ad73a10dc852c32" title="The types of rotational interpolation available.">RotationInterpolationMode</a> <a class="code" href="classOgre_1_1Animation.html#a73cbf633be9d7d066c8592eb7f7201cf">mRotationInterpolationMode</a>;
<a name="l00516"></a>00516 
<a name="l00517"></a><a class="code" href="classOgre_1_1Animation.html#af7548c23de2f7a7247a32b6b51c10d4d">00517</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Animation.html#accd627249080f5a09332f55bed1d2dcd" title="The types of animation interpolation available.">InterpolationMode</a> <a class="code" href="classOgre_1_1Animation.html#af7548c23de2f7a7247a32b6b51c10d4d">msDefaultInterpolationMode</a>;
<a name="l00518"></a><a class="code" href="classOgre_1_1Animation.html#ac86f4ccd6587f674204158c527ae4610">00518</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Animation.html#afbc674fea08fd85e8ad73a10dc852c32" title="The types of rotational interpolation available.">RotationInterpolationMode</a> <a class="code" href="classOgre_1_1Animation.html#ac86f4ccd6587f674204158c527ae4610">msDefaultRotationInterpolationMode</a>;
<a name="l00519"></a>00519 
<a name="l00521"></a><a class="code" href="classOgre_1_1Animation.html#a6edac07b941e6e5143f8698512c54f85">00521</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Real&gt;::type</a> <a class="code" href="classOgre_1_1Animation.html#a6edac07b941e6e5143f8698512c54f85" title="Global keyframe time list used to search global keyframe index.">KeyFrameTimeList</a>;
<a name="l00522"></a><a class="code" href="classOgre_1_1Animation.html#a413a1b1f2a76187c55e117439713ad45">00522</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Animation.html#a6edac07b941e6e5143f8698512c54f85" title="Global keyframe time list used to search global keyframe index.">KeyFrameTimeList</a> <a class="code" href="classOgre_1_1Animation.html#a413a1b1f2a76187c55e117439713ad45">mKeyFrameTimes</a>;
<a name="l00524"></a><a class="code" href="classOgre_1_1Animation.html#aebb49da3e990b742b399f9504434af3d">00524</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Animation.html#aebb49da3e990b742b399f9504434af3d" title="Dirty flag indicate that keyframe time list need to rebuild.">mKeyFrameTimesDirty</a>;
<a name="l00525"></a>00525 
<a name="l00526"></a><a class="code" href="classOgre_1_1Animation.html#a7d787f8568a6ce362cb4216389823c91">00526</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Animation.html#a7d787f8568a6ce362cb4216389823c91">mUseBaseKeyFrame</a>;
<a name="l00527"></a><a class="code" href="classOgre_1_1Animation.html#a2eef637eb31967fccfd0117f1b4249ca">00527</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Animation.html#a2eef637eb31967fccfd0117f1b4249ca">mBaseKeyFrameTime</a>;
<a name="l00528"></a><a class="code" href="classOgre_1_1Animation.html#adf7afa50d30afd8672d2f126acd8f66a">00528</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Animation.html#adf7afa50d30afd8672d2f126acd8f66a">mBaseKeyFrameAnimationName</a>;
<a name="l00529"></a><a class="code" href="classOgre_1_1Animation.html#a98114678abd7fcc0170b221586334d9e">00529</a>         <a class="code" href="classOgre_1_1AnimationContainer.html" title="An animation container interface, which allows generic access to sibling animations.">AnimationContainer</a>* <a class="code" href="classOgre_1_1Animation.html#a98114678abd7fcc0170b221586334d9e">mContainer</a>;
<a name="l00530"></a>00530 
<a name="l00531"></a>00531         <span class="keywordtype">void</span> optimiseNodeTracks(<span class="keywordtype">bool</span> discardIdentityTracks);
<a name="l00532"></a>00532         <span class="keywordtype">void</span> optimiseVertexTracks(<span class="keywordtype">void</span>);
<a name="l00533"></a>00533 
<a name="l00535"></a>00535         <span class="keywordtype">void</span> buildKeyFrameTimeList(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00536"></a>00536     };
<a name="l00537"></a>00537 
<a name="l00540"></a>00540 }
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 <span class="preprocessor">#endif</span>
<a name="l00544"></a>00544 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
